## frama-c 20220511-manganese

=== debian/changelog ===
frama-c (20220511-manganese-5build7) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:18:58 +0000

frama-c (20220511-manganese-5build6) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:22:00 +0000

frama-c (20220511-manganese-5build5) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Feb 2024 08:36:38 +0100

frama-c (20220511-manganese-5build4) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Feb 2024 07:57:00 +0100

frama-c (20220511-manganese-5build3) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:23:27 +0100

frama-c (20220511-manganese-5build2) noble; urgency=medium

  * Rebuild against 'new OCAML ABIs'.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 15 Dec 2023 07:55:32 +0100

frama-c (20220511-manganese-5build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Nov 2023 20:12:29 +0100

frama-c (20220511-manganese-5) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Disable Why3 support (Closes: #1051485)
  * Depend on ocaml instead of transitional ocaml-nox

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-ocaml (>= 0.9~).
    + Build-Depends: Drop versioned constraint on libocamlgraph-ocaml-dev (>=
      1.8.8).

 -- Stéphane Glondu <glondu@debian.org>  Sat, 09 Sep 2023 08:26:56 +0200

frama-c (20220511-manganese-4) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Fix compilation with recent yojson (Closes: #1040537)

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Jul 2023 09:10:19 +0200

frama-c (20220511-manganese-3) unstable; urgency=medium

  * Create a versioned dependency on libwhy3-ocaml-dev (closes: #1023712).
    As a consequence, remove dependency on libwhy3-ocaml-dev in the tests.
  * Standards-Version 4.6.2 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 27 Dec 2022 21:00:26 +0100

frama-c (20220511-manganese-2) unstable; urgency=medium

  * Fix properly the failing autopkgtest "wp" : spurious warning by "why3
    config" has to be sent to /dev/null.

 -- Ralf Treinen <treinen@debian.org>  Sun, 23 Oct 2022 12:25:38 +0200

frama-c (20220511-manganese-1.3) unstable; urgency=medium

  * Tighten the dep on newer why3 also for autopkgtest.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 27 Jun 2022 20:50:40 +0200

frama-c (20220511-manganese-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Tighten the dep on newer why3.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 27 Jun 2022 11:29:05 +0200

frama-c (20220511-manganese-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add crude dep on libppx-import-ocaml by hand (why does dh-ocaml
  fail to detect it?).
  * Add workaround for failing autopkgtest.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 23 Jun 2022 11:46:20 +0200

frama-c (20220511-manganese-1) unstable; urgency=medium

  * New upstream version. This version is compatible with why3 version
    1.5.0 (closes: #1011892,#1010867).
  * Add build-dependency on
    - libppx-import-ocaml-dev
    - libppx-deriving-ocaml-dev
  * debian/copyright: drop mention of plugins that are no longer
    included in the upstream distribution:
    - coqwp
    - ergo
  * Standards-Version 4.6.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sat, 18 Jun 2022 19:39:11 +0200

frama-c (20211203-chromium-1) unstable; urgency=medium

  * New upstream release. This release fixes FTBFS with why3 >= 1.4.0
    (closes: #1000491)
    - drop patch 0001-E-ACSL-avoid-cmx-dependencies-when-in-a-byte-only-ar
      which has been applied upstream.
    - refresh remaining patches
  * install: move libeacsl-dlmalloc.a from usr/lib to usr/lib/frama-c/e-acsl
  * d/copyright: remove some file patterns that no longer apply.
  * d/tests/wp: update call to "why3 config"
  * Standards-Version 4.6.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 22 Mar 2022 08:02:03 +0100
