=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>,
 Ralf Treinen <treinen@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 dh-ocaml,
 graphviz,
 autoconf,
 libzarith-ocaml-dev,
 ocaml-findlib,
 libfindlib-ocaml-dev,
 libyojson-ocaml-dev,
 libocamlgraph-ocaml-dev,
 liblablgtk3-ocaml-dev (>= 3.0~beta4),
 liblablgtksourceview3-ocaml-dev,
 libppx-import-ocaml-dev,
 libppx-deriving-ocaml-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://frama-c.com
Vcs-Browser: https://salsa.debian.org/ocaml-team/frama-c
Vcs-Git: https://salsa.debian.org/ocaml-team/frama-c.git

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 ${perl:Depends},
 libocamlgraph-ocaml-dev, libppx-import-ocaml,
 gcc,
 python3
Recommends:
 alt-ergo, why3
Description: Platform dedicated to the analysis of source code written in C
 Frama-C gathers several analysis techniques in a single collaborative
 framework, based on analyzers (called "plug-ins") that can build upon the
 results computed by other analyzers in the framework.
 .
 Thanks to this approach, Frama-C provides sophisticated tools, including:
   * an analyzer based on abstract interpretation (Value plug-in);
   * a program proof framework based on weakest precondition calculus
     (WP plug-in);
   * a program slicer (Slicing plug-in);
   * a tool for verification of temporal (LTL) properties (Aoraï plug-in);
   * several tools for code base exploration and dependency analysis
     (plug-ins From, Impact, Metrics, Occurrence, Scope, etc.).
 .
 These plug-ins communicate between each other via the Frama-C API
 and via ACSL (ANSI/ISO C Specification Language) properties.
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c, the command-line tools, and the graphical interface.
