=== debian/tests/control ===
Tests: eva
Depends: frama-c-base

Tests: wp
Depends: frama-c-base, alt-ergo (>= 2.0.0), why3
Restrictions: skip-not-installable
